unit untClipboard;

interface

uses
  SysUtils, Classes, Controls, Forms, StdCtrls, Buttons;

type
  TfrmClipboard = class(TForm)
    SpdLock: TSpeedButton;
    SpdUnlock: TSpeedButton;
    SpdEmpty: TSpeedButton;
    SpdSet: TSpeedButton;
    SpdRead: TSpeedButton;
    MemClip: TMemo;
    procedure SpdReadClick(Sender: TObject);
    procedure SpdSetClick(Sender: TObject);
    procedure SpdEmptyClick(Sender: TObject);
    procedure SpdLockClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmClipboard: TfrmClipboard;

implementation

uses untMain, untCommands;
{$R *.DFM}

procedure TfrmClipboard.SpdReadClick(Sender: TObject);
begin
   frmMain.strStatus:='Reading clipboard text...';
   frmMain.SendCommand(COMMAND_CLIP_READ,'');
end;

procedure TfrmClipboard.SpdSetClick(Sender: TObject);
begin
   frmMain.strStatus:='Changing clipboard text...';
   frmMain.SendCommand(COMMAND_CLIP_SET,MemClip.Text);
end;

procedure TfrmClipboard.SpdEmptyClick(Sender: TObject);
begin
   frmMain.strStatus:='Empting clipboard...';
   frmMain.SendCommand(COMMAND_CLIP_EMPTY,'');
end;

procedure TfrmClipboard.SpdLockClick(Sender: TObject);
var
   Index:Integer;
begin
   Index:=(Sender as TSpeedButton).Tag;
   if Index = 1 then
      frmMain.strStatus:='Locking clipboard...'
   else
      frmMain.strStatus:='Unlocking clipboard...';
   frmMain.SendCommand(COMMAND_CLIP_LOCK,IntToStr(Index));
end;

procedure TfrmClipboard.FormCreate(Sender: TObject);
begin
   Caption:='Clipboard manager';
end;

end.
