unit untDateTime;

interface

uses
  SysUtils, Classes, Controls, Forms, StdCtrls, Buttons;

type
  TfrmDateTime = class(TForm)
    GruTime: TGroupBox;
    SpdSetTime: TSpeedButton;
    EdtTime: TEdit;
    CboAMPM: TComboBox;
    GruDate: TGroupBox;
    SpdSetDate: TSpeedButton;
    EdtDate: TEdit;
    SpdReadTimeDate: TSpeedButton;
    procedure SpdReadTimeDateClick(Sender: TObject);
    procedure SpdSetDateClick(Sender: TObject);
    procedure SpdSetTimeClick(Sender: TObject);
    procedure ShowTime(Data: string);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDateTime: TfrmDateTime;

implementation

uses untMain, untCommands;
{$R *.DFM}

procedure TfrmDateTime.SpdReadTimeDateClick(Sender: TObject);
begin
   frmMain.strStatus:='Reading time and date...';
   frmMain.SendCommand(COMMAND_READ_TIME_DATE,'');
end;

procedure TfrmDateTime.SpdSetDateClick(Sender: TObject);
begin
   frmMain.strStatus:='Changing date...';
   frmMain.SendCommand(COMMAND_SET_DATE,Trim(EdtDate.Text));
end;

procedure TfrmDateTime.SpdSetTimeClick(Sender: TObject);
begin
   frmMain.strStatus:='Changing time...';
   frmMain.SendCommand(COMMAND_SET_TIME,Trim(EdtTime.Text) + ' ' + CboAMPM.Text);
end;

procedure TfrmDateTime.ShowTime(Data: string);
var
   p,l:integer;
   strTime,strDate:string;
begin
   p:=Pos('|',Data);
   strTime:=Copy(Data,1,p-1);
   strDate:=Copy(Data,p+1,Length(Data));
   l:=Length(strTime);
   CboAMPM.ItemIndex:=CboAMPM.Items.IndexOf(Copy(strTime,l-1,l));
   EdtTime.Text:=Copy(strTime,1,l-3);
   EdtDate.Text:=strDate;
end;

procedure TfrmDateTime.FormCreate(Sender: TObject);
begin
   Caption:='Date/time';
   CboAMPM.ItemIndex:=0;
end;

end.
