unit untRAS;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, StdCtrls, Buttons, Dialogs;

type
  TfrmRAS = class(TForm)
    GruEntries: TGroupBox;
    LstEntries: TListBox;
    SpdRefresh: TSpeedButton;
    SpdRename: TSpeedButton;
    SpdDelete: TSpeedButton;
    SpdShwEdit: TSpeedButton;
    GruExtra: TGroupBox;
    SpdHangUp: TSpeedButton;
    SpdShwNew: TSpeedButton;
    procedure SpdRefreshClick(Sender: TObject);
    procedure SpdDeleteClick(Sender: TObject);
    procedure SpdRenameClick(Sender: TObject);
    procedure SpdHangUpClick(Sender: TObject);
    procedure SpdShwNewClick(Sender: TObject);
    procedure SpdShwEditClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmRAS: TfrmRAS;

implementation

uses untMain, untCommands;

{$R *.DFM}

procedure TfrmRAS.SpdRefreshClick(Sender: TObject);
begin
   LstEntries.Items.Clear;
   frmMain.strStatus:='Getting RAS entries...';
   frmMain.SendCommand(COMMAND_RAS_ENTRIES,'');
end;

procedure TfrmRAS.SpdDeleteClick(Sender: TObject);
begin
   if not frmMain.ClientMain.Active then
   begin
      frmMain.PutStatus('You''re not connected...');
      Exit;
   end;
   if LstEntries.ItemIndex < 0 then
   begin
      frmMain.PutStatus('Please, select any entry...');
      Exit;
   end;
   if MessageBox(Handle,'Delete selected entry. Are you sure?',
      PChar(frmMain.Caption),MB_ICONQUESTION or MB_YESNO) = ID_NO then
      Exit;
   frmMain.strStatus:='Deleting entry...';
   frmMain.SendCommand(COMMAND_RAS_DELETE,LstEntries.Items[LstEntries.ItemIndex]);
end;

procedure TfrmRAS.SpdRenameClick(Sender: TObject);
var
   OldName,NewName:string;
begin
   if not frmMain.ClientMain.Active then
   begin
      frmMain.PutStatus('You''re not connected...');
      Exit;
   end;
   if LstEntries.ItemIndex < 0 then
   begin
      frmMain.PutStatus('Please, select any entry...');
      Exit;
   end;
   OldName:=LstEntries.Items[LstEntries.ItemIndex];
   NewName:=OldName;
   if InputQuery(frmMain.Caption,'Enter the new name to entry:',NewName) then
   begin
      if UpperCase(Trim(NewName)) = UpperCase(Trim(OldName)) then
      begin
         frmMain.PutStatus('Please, enter a different name...');
         Exit;
      end;
      application.title:=OldName;
      frmMain.strStatus:='Renaming entry...';
      frmMain.SendCommand(COMMAND_RAS_RENAME,OldName + Chr(13) + NewName);
   end;
end;

procedure TfrmRAS.SpdHangUpClick(Sender: TObject);
begin
   frmMain.strStatus:='Hanging up...';
   frmMain.SendCommand(COMMAND_RAS_HANG_UP,'');
end;

procedure TfrmRAS.SpdShwNewClick(Sender: TObject);
begin
   frmMain.strStatus:='Showing new connection dialog...';
   frmMain.SendCommand(COMMAND_RAS_NEW_CONN,'');
end;

procedure TfrmRAS.SpdShwEditClick(Sender: TObject);
begin
   if not frmMain.ClientMain.Active then
   begin
      frmMain.PutStatus('You''re not connected...');
      Exit;
   end;
   if LstEntries.ItemIndex < 0 then
   begin
      frmMain.PutStatus('Please, select any entry...');
      Exit;
   end;
   frmMain.strStatus:='Showing edit dialog...';
   frmMain.SendCommand(COMMAND_RAS_EDIT,LstEntries.Items[LstEntries.ItemIndex]);
end;

end.
