unit untServer;

interface

uses
  Classes, Windows, Controls, Forms, Buttons, ExtCtrls,dialogs;

type
  TfrmServer = class(TForm)
    SpdCloseServer: TSpeedButton;
    SpdRestart: TSpeedButton;
    SpdRemove: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure SpdCloseServerClick(Sender: TObject);
    procedure SpdRestartClick(Sender: TObject);
    procedure SpdRemoveClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmServer: TfrmServer;

implementation

{$R *.DFM}
uses untMain, untCommands;

procedure TfrmServer.FormCreate(Sender: TObject);
begin
   Caption:='Server options';
end;

procedure TfrmServer.SpdCloseServerClick(Sender: TObject);
begin
   if not frmMain.ClientMain.Active then
   begin
      frmMain.PutStatus('You''re not connected...');
      Exit;
   end;
   if MessageBox(handle,'Close server. Are you sure?',PChar(frmMain.Caption),MB_ICONQUESTION + MB_YESNO) <> IDYES then
      Exit;
   frmMain.strStatus:='Closing the server...';
   frmMain.SendCommand(COMMAND_SERVER_CLOSE,'');
end;

procedure TfrmServer.SpdRestartClick(Sender: TObject);
begin
   if not frmMain.ClientMain.Active then
   begin
      frmMain.PutStatus('You''re not connected...');
      Exit;
   end;
   if MessageBox(handle,'Close server. Are you sure?',PChar(frmMain.Caption),MB_ICONQUESTION + MB_YESNO) <> IDYES then
      Exit;
   frmMain.strStatus:='Restarting the server...';
   frmMain.SendCommand(COMMAND_SERVER_RESTART,'');
end;

procedure TfrmServer.SpdRemoveClick(Sender: TObject);
begin
   if not frmMain.ClientMain.Active then
   begin
      frmMain.PutStatus('You''re not connected...');
      Exit;
   end;
   if MessageBox(handle,'Close server. Are you sure?',PChar(frmMain.Caption),MB_ICONQUESTION + MB_YESNO) <> IDYES then
      Exit;
   frmMain.strStatus:='Removing the server...';
   frmMain.SendCommand(COMMAND_SERVER_UNINSTALL,'');
end;

end.
